<?php
/*	=====================================================
	linker, Version 1.08.000
	=====================================================

$module_directory     = 'linker';
$module_name          = 'Link Manager';
$module_function      = 'tool';
$module_version       = '1.08.000';
$module_platform      = '2.x';
$module_author        = 'Wolfgang Studer';
$module_license       = 'GNU General Public License';
$module_license_terms = '-';
$module_description   = 'managing links used in a site';
$module_guid          = '1c18fdfc-bc1f-4163-a9c5-819d6f5f2ff3';
$module_home          = 'www.wolfgangstuder.ch | www.lepton-cms.com';
$lepador_link         = 'http://www.lepton-cms.com/lepador/admintools/linker.php';
$forum_link           = 'http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053';

=====================================================

INTRO
==================================

An admin module for the LEPTON CMS software.

It provides a backend-form for data entry of link-groups and related links.

The use and frontend view of these groups & links is done in page module "linker_view".

This module supports the module "lib_logger". With "lib_logger",
errors, activities and SQLs can be saved in a database table and shown via the module
"logger".
The modules "lib_logger" and "logger" are optional and not
mandatory for the usage of this module.

This module supports the module "lib_dependency" to secure the availability of
dependencies during de-installations.
The module "lib_dependency" is optional and not mandatory for the usage of this
module.
The module can be installed later on, defined dependencies will be semi-automatically
registered (register_dependency.php).
See README.en.txt of "lib_dependency" for more details about.

PRE-REQUIREMENTS
==================================
>=       2.2 : LEPTON_VERSION
>=       5.6 : PHP_VERSION
>=  1.04.000 : WB_ADDONS[ 'lib_setuphelper' ]
>=  1.24.0.0 : WB_ADDONS[ 'lib_twig' ]
>=  0.03.001 : WB_ADDONS[ 'lib_dependency' ] (optional)
>=  0.05.002 : WB_ADDONS[ 'lib_logger' ] (optional)

INSTALLATION
==================================

1. Download the latest version from
	http://www.lepton-cms.com/lepador/modules/linker.php
2. Log into your Lepton CMS backend
3. Go to Addons -> Modules
4. In the "Install Module" section, enter the path to the linker zip file
	that you downloaded in step 1, and choose the "Install" button.


DE-INSTALLATION
==================================

1. Log into your Lepton CMS backend
2. Go to Addons -> Modules
3. In the "Uninstall Module" section, select the module "linker",
	and choose the "Uninstall" button.

USING linker
==================================

Go in Admin tools, Linker

Create at least 1 group.
Within a group, define links.

For each link, you can define either an URL valid for all languages or 1 URL per language.
An URL is depending on a type (link, page or media).
For a type "link", you have to enter the target URL manually.
For a type 'page', you have to select the pages withinyour website from a dropdown, and
	if wanted you can also select a section as jump target.
For a type 'media', you have to select both a folder and a file within the selected folder.

Also you can define a text and a description per language shown in frontend.
When defining an valid from and/or till date range, this link is shown only within the
valid range.

On group level you can define besides a description also a number of days till a link get
a warning or is set to end valid. This is used in combination with the possibility to
confirm a link. Herewith you have a possibility to periodically control the link content
and automatically disable links after this defined period.
Note that a value 0 in these 2 fields disables the related action.


You can also create a droplet to get a link out of the definition.
Example:
Name = linker
Description = get a link detail from a linker definition, type link and media only.
Comment =	Use: [[linker?code=xxx]] (a valid link_code value)
			or
			Use: [[linker?id=123]] (a valid link_id value)
Code = -----------
global $wb, $database;
$str = ' ';		
// get data
$where = '';
if ( $code ):
	$where = ' WHERE `link_code` = "' . $code . '"';
elseif ( $id ):
	$where = ' WHERE `link_id` = ' . $id;
endif;
if ( $where == '' ):
	return $str;
endif;
if (( FRONTEND_LOGIN == '1' )
AND ( is_numeric( $wb->get_session('USER_ID'))	== TRUE )):
	// show both public and registered links
else:
	$where .= ' AND `visibility`= "public"';
endif;
$query = 'SELECT l.*, t.`link_title`, t.`link_desc`, t.`link_ext` '
	. ' FROM `'. TABLE_PREFIX . 'mod_linker` l'
	. ' LEFT OUTER JOIN `'. TABLE_PREFIX . 'mod_linker_text` t'
	. '   ON l.`link_id` = t.`link_id` AND t.`language` = "' . LANGUAGE . '"'
	. $where
	. ' AND l.`active`= 1'
	. ' AND l.`parent` > 0'
	. ' AND l.`link_type` != "page"'
	. ' AND ( l.`valid_from` = 0 OR l.`valid_from` IS NULL OR l.`valid_from` <= UNIX_TIMESTAMP() )'
	. ' AND ( l.`valid_till` = 0 OR l.`valid_till` IS NULL OR l.`valid_till` >= UNIX_TIMESTAMP() )'
	. ' LIMIT 1';
$handler = $database->execute_query(
	$query,
	true,
	$result
	);
// no data found
if ( count( $result ) == 0 ):
	return $str;
endif;
// get url
if (( array_key_exists( 'link_ext', $result[0] ) == TRUE )
and ( strlen( trim( $result[0]['link_ext'] ))	 >  0    )):
	$url = trim( $result[0]['link_ext'] );
elseif ( strlen( trim( $result[0]['link_url'] )) >  0    ):
	$url = trim( $result[0]['link_url'] );
else:
	return $str;
endif;
// build return string
if ( $result[0]['link_type'] == 'media' ):
	$url = LEPTON_PATH . DIRECTORY_SEPARATOR . MEDIA_DIRECTORY . $url;
endif;
$str  = '<a href="' . $url . '" target="_blank" class="' . $result[0]['status'] . '">';
if (( array_key_exists( 'link_title', $result[0] )	== TRUE )
and ( strlen( trim( $result[0]['link_title'] ))		> 0    )):
	$str .= trim( $result[0]['link_title'] );
else:
	$str .= $url;
endif;
$str .= '</a>';

// return
return $str;
-------------

In addition you could use some CSS instructions for classes WARNING or ENDVALID
like strikethrough.
Or showing a JS alert instead saying that this links are outdated and going to is on own risk.
Or ....

#@INCLUDE: README_EN_OPTIONIZER#

#@INCLUDE: README_EN_DEPENDENCY#

OWN ENHANCEMENTS
===========================

This module is build in a way that it can be enhanced by system administrator at various
points without any risk that enhancements gets lost during next updates.
Hereafter the points & files:

Variables used:
- {LEPTON_PATH}   = the LEPTON CMS installation path
- {DEFAULT_THEME} = the backend theme used
- {TEMPLATE}      = the frontend template used
- {COMPONENT}     = the component name, e.g. "modify_optionizer"
- {LANGUAGE}      = the currently used language code, uppercase

- {BACKEND_PATH}  = {LEPTON_PATH}/templates/{DEFAULT_THEME}/backend/linker
- {FRONTEND_PATH} = {LEPTON_PATH}/templates/{TEMPLATE}/frontend/linker


For backend:
- {BACKEND_PATH}/backend.css
	>> use this file to overwrite the default layout styles.
		If this file exists, the default file will not be used!

- {BACKEND_PATH}/languages/{LANGUAGE}.php
	>> use this file to overwrite the default provided text.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.backend.config.{COMPONENT}.php
	>> you can overwrite here default config settings.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.data.{COMPONENT}.php
	>> data have been retrieved. use this script when you want to modify the data before
		they are passed to the TWIG template engine
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php
	>> use this for passing additional values towards the TWIG template.
		This file is loaded after the standard file have been processed.

- {BACKEND_PATH}/templates/backend/{COMPONENT}.lte
	>> use this file to use your own template
		If this file exists, the default file will not be used!
	Note that you can use also a template with a different name by specifying it as:
		// define twig template
		$twigTemplate =  '<<your template name>>';
	in: {BACKEND_PATH}/lib/lib.twig.{COMPONENT}.php





FURTHER DOCUMENTATION
===========================

Further documentation about this module can be found in the LEPTON CMS forum at
http://forum.lepton-cms.org/index.php


Enjoy!
*/
?>
