<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/*	**************************************
	*
	* define array with table definitions and activities to be done in
	* - install.php
	* - upgrade.php
	* - uninstall.php
	* - add.php
	* - delete.php
	*
	**************************************
*/

// init array
	$module_DB_setup = array();


/* ==================================================================================
 * For a description of this array and the possibilities, see
 * LEPTON_PATH . '/modules/lib_setuphelper/examples/_setup.php'
 * ==================================================================================
 */

/*	**************************************
	*
	* module table: mod_linker
	*
	**************************************
*/
	$table = TABLE_PREFIX . 'mod_linker';
	$module_DB_setup[ $table ][ 'index' ][]		= 'PRIMARY KEY (`link_id`)';
	$module_DB_setup[ $table ][ 'index' ][]		= 'INDEX `' . $table . '_I01` (`parent`,`position`)';
	$module_DB_setup[ $table ][ 'options' ][]	= 'COMMENT "contain links on a site"';
	$module_DB_setup[ $table ][ 'fields' ]		= array(
			  array(
				  'Field'	=> 'link_id'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Key'		=> 'PRI'
				, 'Extra'	=> 'AUTO_INCREMENT'
				, 'Options'	=> 'COMMENT "Primary Key"'
				)
			, array(
				  'Field'	=> 'created_when'
				, 'Type'	=> 'TIMESTAMP'
				, 'Null'	=> 'NO'
				, 'Default'	=> '"0000-00-00 00:00:00"'
				)
			, array(
				  'Field'	=> 'modified_when'
				, 'Type'	=> 'TIMESTAMP'
				, 'Null'	=> 'NO'
				, 'Default'	=> 'CURRENT_TIMESTAMP'
				, 'Extra'	=> 'ON UPDATE CURRENT_TIMESTAMP'
				)
			, array(
				  'Field'	=> 'modified_by'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'version_number'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'active'
				, 'Type'	=> 'TINYINT(4)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '1'
				)
			, array(
				  'Field'	=> 'status'
				, 'Type'	=> 'VARCHAR(20)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '"OK"'
				, 'Options'	=> 'COMMENT "OK, WARNING, ENDVALID, DELETED"'
				)
			, array(
				  'Field'	=> 'parent'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				, 'Options'	=> 'COMMENT "0=group, >0=link_id of group"'
				)
			, array(
				  'Field'	=> 'position'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'group_collection'
				, 'Type'	=> 'VARCHAR(100)'
				)
			, array(
				  'Field'	=> 'group_name'
				, 'Type'	=> 'VARCHAR(100)'
				, 'Null'	=> 'NO'
				)
			, array(
				  'Field'	=> 'link_code'
				, 'Type'	=> 'VARCHAR(100)'
				)
			, array(
				  'Field'	=> 'link_type'
				, 'Type'	=> 'VARCHAR(10)'
				, 'Default'	=> '"link"'
				)
			, array(
				  'Field'	=> 'link_url'
				, 'Type'	=> 'VARCHAR(255)'
				)
			, array(
				  'Field'	=> 'last_confirmed_when'
				, 'Type'	=> 'TIMESTAMP'
				)
			, array(
				  'Field'	=> 'last_confirmed_by'
				, 'Type'	=> 'INT(11)'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'valid_from'
				, 'Type'	=> 'INT(11)'
				)
			, array(
				  'Field'	=> 'valid_till'
				, 'Type'	=> 'INT(11)'
				)
			, array(
				  'Field'	=> 'confirmation_age_warning'
				, 'Type'	=> 'SMALLINT(4)'
				, 'Options'	=> 'COMMENT "0=off, >0=number of days"'
				)
			, array(
				  'Field'	=> 'confirmation_age_endvalid'
				, 'Type'	=> 'SMALLINT(4)'
				, 'Options'	=> 'COMMENT "0=off, >0=number of days"'
				)
			, array(
				  'Field'	=> 'visibility'
				, 'Type'	=> 'VARCHAR(255)'
				, 'Default'	=> '"public"'
				)
			, array(
				  'Field'	=> 'release_code'
				, 'Type'	=> 'VARCHAR(255)'
				)
		);

	$module_DB_setup[ 'INSTALL' ][ $table ][ 'DO' ]			= TRUE;

	$module_DB_setup[ 'UPGRADE' ][ $table ][ 'DO' ]			= TRUE;

	$module_DB_setup[ 'UNINSTALL' ][ $table ][ 'DO' ]		= TRUE;

	// update all existing links to link_type "link" when link_type is empty
	$module_DB_setup[ 'UPGRADE' ][ $table ][ 'POST' ][]		= array(
											  'REQUEST'	=> 'UPDATE'
											, 'FIELDS'	=> array(
												  'modified_by'		=> '#USER_ID#'
												, 'version_number'	=> 'version_number + 1'
												, 'link_type'		=> 'link'
												)
											, 'WHERE'	=> '`link_type` = "" or `link_type` IS NULL'
											);

/*	**************************************
	*
	* module table: mod_linker_text
	*
	**************************************
*/
	$table = TABLE_PREFIX . 'mod_linker_text';
	$module_DB_setup[ $table ][ 'index' ][]		= 'PRIMARY KEY (`link_id`, `language`)';
	$module_DB_setup[ $table ][ 'options' ][]	= 'COMMENT "contain names to links on a site"';
	$module_DB_setup[ $table ][ 'fields' ]		= array(
			  array(
				  'Field'	=> 'link_id'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Key'		=> 'PRI'
				, 'Options'	=> 'COMMENT "Primary Key"'
				)
			, array(
				  'Field'	=> 'language'
				, 'Type'	=> 'CHAR(3)'
				, 'Null'	=> 'NO'
				, 'Key'		=> 'PRI'
				, 'Options'	=> 'COMMENT "Primary Key"'
				)
			, array(
				  'Field'	=> 'created_when'
				, 'Type'	=> 'TIMESTAMP'
				, 'Null'	=> 'NO'
				, 'Default'	=> '"0000-00-00 00:00:00"'
				)
			, array(
				  'Field'	=> 'modified_when'
				, 'Type'	=> 'TIMESTAMP'
				, 'Null'	=> 'NO'
				, 'Default'	=> 'CURRENT_TIMESTAMP'
				, 'Extra'	=> 'ON UPDATE CURRENT_TIMESTAMP'
				)
			, array(
				  'Field'	=> 'modified_by'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'version_number'
				, 'Type'	=> 'INT(11)'
				, 'Null'	=> 'NO'
				, 'Default'	=> '0'
				)
			, array(
				  'Field'	=> 'link_title'
				, 'Type'	=> 'VARCHAR(100)'
				)
			, array(
				  'Field'	=> 'link_ext'
				, 'Type'	=> 'VARCHAR(255)'
				)
			, array(
				  'Field'	=> 'link_desc'
				, 'Type'	=> 'TEXT'
				)
		);

	$module_DB_setup[ 'INSTALL' ][ $table ][ 'DO' ]			= TRUE;

	$module_DB_setup[ 'UPGRADE' ][ $table ][ 'DO' ]			= TRUE;

	$module_DB_setup[ 'UNINSTALL' ][ $table ][ 'DO' ]		= TRUE;


?>
