<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/*
 * Ajax call: autocomplete
 */
// check input
// "term" is what jquery autocomplete is send as input
	$inputs = array();
	$inputs[ 'term' ] = array( 'filter' => FILTER_SANITIZE_STRING, 'required' => 1 );

// set $module as current module
	$linker_module = 'linker';

// set processing initials
	unset( $twigTemplate );
	$linker_component = basename( __FILE__, '.php' );
	$linker_modulePath = dirname( __FILE__ ) . DIRECTORY_SEPARATOR;
	$includes = array();

// Include admin class script
	include( LEPTON_PATH . '/framework/class.admin.php');
	$admin = new admin( 'Dialog', 'start', false, false );

// include the basic files at start
	// setup module initials
	$includes[]	= array( 'LOADER'=> 'require', 'FILE' => $linker_modulePath . 'register_initial.php' );
	include( $linker_modulePath . 'load_includes.php' );

	// include language registration
	$includes[]	= $linker_modulePath . 'register_language.php';
	// include backend config files
	$includes[]	= $linker_modulePath . 'lib/lib.config.php';
	$includes[]	= $linker_modulePath . 'lib/lib.backend.config.php';
	$includes[]	= $linker_templatePath . 'lib/lib.backend.config.php';
	$includes[]	= $linker_modulePath . 'lib/lib.backend.config.' . $linker_component . '.php';
	$includes[]	= $linker_templatePath . 'lib/lib.backend.config.' . $linker_component . '.php';
	// include basic functions
	$includes[]	= $linker_templatePath . 'lib/lib.backend.functions.' . $linker_component . '.php';
	$includes[]	= $linker_templatePath . 'lib/lib.backend.functions.php';
	$includes[]	= $linker_modulePath . 'lib/lib.backend.functions.' . $linker_component . '.php';
	$includes[]	= $linker_modulePath . 'lib/lib.backend.functions.php';
	// do include
	include( $linker_modulePath . 'load_includes.php' );

	// initialize data variable
	$data = array();

// assign default type used in language files
	$type = $linker_component;

// initialize messages shown in dialog
	$messages = array();

// initialize data variable
	$data = array();

// init ajax output
	$linker_response = '';

// do input validation
	if ( $_SERVER["REQUEST_METHOD"] == 'POST' ):
		$error = linker_input_filter( 'POST', $_POST, $inputs );
	else:
		$error = linker_input_filter( 'GET', $_GET, $inputs );
	endif;
	$linker_response = '';
	$linker_action   = '';
	if ( $error != 0 ):
		$status = FALSE;
		unset( $inputs );

	else:
		// save input into local vars
		$autocompleteString = $inputs[ 'term' ][ 'value' ];

		unset( $inputs );

		// initialize status
		$status = TRUE;

		// prepare SQL
		// no data access here

		// data manipulation
				// include data manipulation files
		$includes[]	= $linker_modulePath . 'lib/lib.data.php';
		$includes[]	= $linker_templatePath . 'lib/lib.data.php';
		$includes[]	= $linker_modulePath . 'lib/lib.data.' . $linker_component . '.php';
		$includes[]	= $linker_templatePath . 'lib/lib.data.' . $linker_component . '.php';
		include( $linker_modulePath . 'load_includes.php' );

		// data manipulation
		// include data manipulation files
		$includes[]	= $linker_modulePath . 'lib/lib.data.php';
		$includes[]	= $linker_templatePath . 'lib/lib.data.php';
		$includes[]	= $linker_modulePath . 'lib/lib.data.' . $linker_component . '.php';
		$includes[]	= $linker_templatePath . 'lib/lib.data.' . $linker_component . '.php';
		include( $linker_modulePath . 'load_includes.php' );
	endif;

// output
	if ( count( $data ) > 0 ):
		echo json_encode(array_unique($data));
	else:
		echo '';
	endif;
	return true;
?>
