
/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


/*
 * initialize sort after page loaded
 */
$(document).ready(function()
{
	/*
	 * sort rows
	 */
	// Return a helper with preserved width of cells
	var fixHelper = function(e, ui)
	{
		ui.children().children().each(function()
		{
			$(this).width($(this).width());
		});
		return ui;
	};

	$('#sortableTable').sortable(
	{
		opacity: 0.6
		, helper: fixHelper
		, items: 'tbody'
		, cursor: 'move'
		, update: function()
		{
			// LEPTON_URL+
			var url = '/modules/linker/ajax.sort_rows.php';
			var postdata = {
				action: 'updateRecordsListings'
				, row_key: linker_ROWKEY
				, recordsArray: $(this).sortable('serialize')
			}

			var fieldIds = [ 'leptoken' ];
			fieldIds.forEach(function (s, i, o)
			{
				postdata[s] = document.getElementById( s ).value;
			});

			$.ajax({
				url: url
				, type: 'post'
				, dataType: 'json'
				, data: postdata
				, success: function (data)
				{
					$('#linker_sortable_result').html( data.ResponseText );
				}
			});
		}
		, items: 'tbody:not(.sort_disable)'
	});
	$( "#sortableTable" ).on( "sortstart", function( event, ui )
	{
		$('#linker_sortable_result').html( '' );
	});
});
