
/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


/*
 * toggles active flag
 */
function linker_toggle_active( row_id, setMarker, dialogTitle )
{
	// ajax call to set flag and return info box
			// LEPTON_URL+
	var url = '/modules/linker/ajax.toggle_active.php';
	var postdata = {
		action: 'toggle'
		, row_key: linker_ROWKEY
		, row_id: row_id
	}

	var fieldIds = [ 'leptoken' ];
	fieldIds.forEach(function (s, i, o)
	{
		postdata[s] = document.getElementById( s ).value;
	});

	$.ajax({
		url: url
		, type: 'post'
		, dataType: 'json'
		, data: postdata
		, success: function ( data )
			{
				// handle active flag returned
				var data_active = data.data.active;
				if( data_active == 1 )
				{
					$( '#img_active_'   + row_id ).removeClass( 'hidden' );
					$( '#img_inactive_' + row_id ).addClass( 'hidden' );
					if( setMarker == 1 )
					{
						$( '#marker_'   + row_id ).removeClass( 'deleted' );
					}
				}
				else
				{
					$( '#img_active_'   + row_id ).addClass( 'hidden' );
					$( '#img_inactive_' + row_id ).removeClass( 'hidden' );
					if( setMarker == 1 )
					{
						$( '#marker_'   + row_id ).addClass( 'deleted' );
					}
				}

				// create the dialog with default options
				linker_show_dialog( dialogTitle, data.ResponseText );

				// add timeout event to automatically close the dialog after 2 seconds
				linker_close_on_timeout( data.status, 2 );
			}
	});
};
