<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// Titel
	$MOD_LINKER['H2']['main']				= 'Manage link groups';
	$MOD_LINKER['H2']['addgroup']			= 'Add link group';
	$MOD_LINKER['H2']['group']				= 'Manage group';
	$MOD_LINKER['H2']['links']				= 'Manage links';

// field names
	$MOD_LINKER['FLD']['link_id']			= 'ID';
	$MOD_LINKER['FLD']['group_collection']	= 'Collection';
	$MOD_LINKER['FLD']['group_name']		= 'Link Group';
	$MOD_LINKER['FLD']['release_code']		= 'Release';
	$MOD_LINKER['FLD']['count']				= 'Links';
	$MOD_LINKER['FLD']['oldest_confirmed']	= 'Oldest Confirmation';
	$MOD_LINKER['FLD']['not_confirmed']		= 't.b.d.';
	$MOD_LINKER['FLD']['group_title']		= 'Group title';
	$MOD_LINKER['FLD']['group_desc']		= 'Group description';
	$MOD_LINKER['FLD']['link_code']			= 'Code';
	$MOD_LINKER['FLD']['link_type']			= 'Type';
	$MOD_LINKER['FLD']['link_url']			= 'URL';
	$MOD_LINKER['FLD']['status']			= 'Status';
	$MOD_LINKER['FLD']['link_title']		= 'Link title';
	$MOD_LINKER['FLD']['link_desc']			= 'Link description';
	$MOD_LINKER['FLD']['link_ext']			= 'Link language URL';
	$MOD_LINKER['FLD']['valid_from']		= 'Start Date';
	$MOD_LINKER['FLD']['valid_till']		= 'End Date';
	$MOD_LINKER['FLD']['last_confirmed']	= 'Last confirmation';
	$MOD_LINKER['FLD']['confirmation_age_warning']	= 'Days till WARNING';
	$MOD_LINKER['FLD']['confirmation_age_endvalid']	= 'Days till ENDVALID';
	$MOD_LINKER['FLD']['visibility']		= 'Visibility';

// placeholders
	$MOD_LINKER['PLH']['group_name']		= '';

// helptext values
	// if such a value is set, the help icon is shown with this text as title
	$MOD_LINKER['HLP']['link_id']			= 'The technical key of this link. Can be used in droplets, however use of code is proposed!';
	$MOD_LINKER['HLP']['group_collection']	= 'A Collection name, where several link groups can be part of. Used in >linker view< module for selection.';
	$MOD_LINKER['HLP']['group_name']		= 'A group name, where several single links can be part of. Used in >linker view< module for selection.';
	$MOD_LINKER['HLP']['release_code']		= 'An optional release code, which can be used to release the defined link, example for download of media files.' . '<br />' . 'Both release codes on group and on link level can be used together or exclusivly.';
	$MOD_LINKER['HLP']['in_active']			= 'Set this group to active or inactive.';
	$MOD_LINKER['HLP']['active']			= 'Set this group to inactive.';
	$MOD_LINKER['HLP']['inactive']			= 'Set this group to active.';
	$MOD_LINKER['HLP']['delete_group']		= 'Delete this group and all included links into trash! Deleting a group definitivly, you have to do the delete the group on the main page.';
	$MOD_LINKER['HLP']['restore_group']		= 'Restore this group from the trash';
	$MOD_LINKER['HLP']['count']				= 'Number of links within this group.';
	$MOD_LINKER['HLP']['count_ok']			= 'Number of links in status OK.';
	$MOD_LINKER['HLP']['count_warning']		= 'Number of links in status WARNING.';
	$MOD_LINKER['HLP']['count_endvalid']	= 'Number of links in status ENDVALID.';
	$MOD_LINKER['HLP']['oldest_confirmed']	= 'Oldest confirmation date';
	$MOD_LINKER['HLP']['not_confirmed']		= 'Number of not confirmed links.';
	$MOD_LINKER['HLP']['group_title']		= 'Language dependend group title, used in frontend.';
	$MOD_LINKER['HLP']['group_desc']		= 'Language dependend group description, used in frontend.';
	$MOD_LINKER['HLP']['link_code']			= 'A unique link code to be used in droplets for direct usage.';
	$MOD_LINKER['HLP']['link_type']			= 'The link type defines the kind of the link.';
	$MOD_LINKER['HLP']['link_url']			= 'The URL of the link. The entry is based on the link type.';
	$MOD_LINKER['HLP']['status']			= 'The review status of the link, depending on the last confirmed visits.';
	$MOD_LINKER['HLP']['link_title']		= 'Language dependend link title, used in frontend.';
	$MOD_LINKER['HLP']['link_desc']			= 'Language dependend link description, used in frontend.';
	$MOD_LINKER['HLP']['link_ext']			= 'Language dependend link URL, used in frontend instead of generic link URL.';
	$MOD_LINKER['HLP']['valid_from']		= 'Defines the start date, from which onwards this link is shown in frontend. Time used is 00:00';
	$MOD_LINKER['HLP']['valid_till']		= 'Defines end date, till this link is shown in frontend. Time used is 00:00';
	$MOD_LINKER['HLP']['last_confirmed']	= 'Last confirmation of the target URL content on this link.';
	$MOD_LINKER['HLP']['confirmation_age_warning']	= 'Number of days since last confirmation till a link change status from OK to WARNING. A value = 0 switch off this change.';
	$MOD_LINKER['HLP']['confirmation_age_endvalid']	= 'Number of days since last confirmation till a link change status to ENDVALID. A value = 0 switch off this change. Note that links in status ENDVALID are no longer shown in frontend!';
	$MOD_LINKER['HLP']['visibility']		= 'Defines who can see the links of this group in frontend.';

// Button name
	$MOD_LINKER['BTN']['accept']			= 'Save & back';
	$MOD_LINKER['BTN']['add_group']			= 'Add a group ...';
	$MOD_LINKER['BTN']['add_link']			= 'Add a link ...';

// tooltips
	$MOD_LINKER['TIP']['modify_links']		= 'Manage links of this group';
	$MOD_LINKER['TIP']['delete_date']		= 'Clear the date field';
	$MOD_LINKER['TIP']['visit']				= 'Visit website';
	$MOD_LINKER['TIP']['deleted_link']		= 'The link is marked for deletion. Any confirmation is useless!';
	$MOD_LINKER['TIP']['confirm_link']		= 'There is no valid link confirmation at the moment. Please confirm the link!';
	$MOD_LINKER['TIP']['confirmed_link']	= 'A valid link confirmation exists. An actualalization is possible.';
	$MOD_LINKER['TIP']['OK']				= 'The link has been confirmed.';
	$MOD_LINKER['TIP']['WARNING']			= 'The link is confirmed but close to get invalid.';
	$MOD_LINKER['TIP']['ENDVALID']			= 'The link confirmation is invalid or out of the validation date range.';
	$MOD_LINKER['TIP']['DELETED']			= 'The link has been marked as deleted.';
	$MOD_LINKER['TIP']['UNDEFINED']			= 'The link has not been confirmed yet.';
	$MOD_LINKER['TIP']['active']			= 'This group is active.';
	$MOD_LINKER['TIP']['inactive']			= 'This group is inactive.';

// JS dialog titles
	$MOD_LINKER['DIALOG']['toggle_active']	= 'Active / Inactive';
	$MOD_LINKER['DIALOG']['validate']		= 'Validation';
	$MOD_LINKER['DIALOG']['restore_row']	= 'Restore Link/Link Group';
	$MOD_LINKER['DIALOG']['delete_row']		= 'Delete Link/Link Group';
	$MOD_LINKER['DIALOG']['confirm_link']	= 'Confirm link definition';
	$MOD_LINKER['DIALOG']['status']			= 'Link status';

	$MOD_LINKER['CONFIRM']['confirm_link']	= 'Can you confirm that this link contains what you expect ?';

// error
	$MOD_LINKER['addgroup']['exists']		= 'This Group name already exists and can not be created again.';
	$MOD_LINKER['addgroup']['empty']		= 'Please enter a group name first.';
	$MOD_LINKER['deletegroup']['not_exists']= 'This Group does not exists in the database.';
	$MOD_LINKER['deletegroup']['empty']		= 'The link key must be provided.';
	$MOD_LINKER['savelinks']['nodata']		= 'No data found to for saving.';
	$MOD_LINKER['savelinks']['group_name']	= 'The Group Name is missing.';

// ok
	$MOD_LINKER['addgroup']['not_exists']	= 'This group name can be created.';

// visibility
	$MOD_LINKER['VISIBILITY']['public']		= 'Public';
	$MOD_LINKER['VISIBILITY']['registered']	= 'Registered';
	$MOD_LINKER['VISIBILITY']['none']		= 'None';

// link types
	$MOD_LINKER['LINKTYPE']['link']			= 'Link';
	$MOD_LINKER['LINKTYPE']['page']			= 'Page';
	$MOD_LINKER['LINKTYPE']['media']		= 'Media';

// page & media
	$MOD_LINKER['section_list']['mainselect']	= 'Please select first the page!';
	$MOD_LINKER['file_list']['mainselect']		= 'Please select first the folder!';

// errors
	$MOD_LINKER['ERROR']['delete_forbidden']	= 'Group is still in use. Delete is not allowed!';

?>
