<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/** ------------------------------------------------------------------------------------
 * build list of page languages
 * @return	array		list of page languages
 * @param	string		$defLang = default language
 ** ------------------------------------------------------------------------------------
 */
if ( function_exists( 'linker_get_page_languages' ) == FALSE ):
	function linker_get_page_languages( $deflang = LANGUAGE )
	{
		// get all page languages
		$languages = array();
		$query = 'SELECT DISTINCT `language` '
					. ' FROM ' . TABLE_PREFIX . 'pages'
					;
		$languages = linker_execute_query( __FUNCTION__, $query, 'get_all' );

		// assign default
		if ( count( $languages ) == 0 ):
			$languages[0]['language'] = $deflang;
		endif;

		// build pageLanguages lists
		$pageLanguages		= array();

		foreach ( $languages as $language ):
			$lang = $language['language'];
			$pageLanguages[ $lang ] = $lang;	// include all available languages
		endforeach;

		// sort
		ksort( $pageLanguages );

		// return
		return $pageLanguages;
	}
endif;

?>
