<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/** ------------------------------------------------------------------------------------
 * build list of page languages
 * @return	string		new format
 * @param	string		$sourceFormat = the format to transform
 * @param	string		$sourceSystem = 'PHP', 'UI'
 * @param	string		$targetSystem = 'PHP', 'UI'
 ** ------------------------------------------------------------------------------------
 */
if ( function_exists( 'linker_transform_datetime_format' ) == FALSE ):
	function linker_transform_datetime_format( $sourceFormat = '', $sourceSystem = 'PHP', $targetSystem = 'UI' )
	{
		// define transformation array
		$transform = array();
		$unsupported = array();
		switch( $sourceSystem . '-' . $targetSystem ):
		case 'PHP-UI':
			// transform from PHP date formats to jquery UI
			$transform = array(
				// Day
				'd' => 'dd',
				'D' => 'D',
				'j' => 'd',
				'l' => 'DD',
				'N' => '',
				'S' => '',
				'w' => '',
				'z' => 'o',
				// Week
				'W' => '',
				// Month
				'F' => 'MM',
				'm' => 'mm',
				'M' => 'M',
				'n' => 'm',
				't' => '',
				// Year
				'L' => '',
				'o' => '',
				'Y' => 'yy',
				'y' => 'y',
				// Time
				'a' => '',
				'A' => '',
				'B' => '',
				'g' => '',
				'G' => '',
				'h' => '',
				'H' => '',
				'i' => '',
				's' => '',
				'u' => ''
			);

			// handle shortcuts
			switch ( $sourceFormat ):
			case 'c':
				$sourceFormat = 'Y-m-dTH:i:sP';
				break;
			case 'r':
				$sourceFormat = 'D, d M Y H:i:s O';
				break;
			endswitch;

			// default format to be used when unsupported items occurs
			$defaultFormat = 'd-m-Y';
			break;

		default:
			// unsupported conversion
			return '--d-m-y--';

		endswitch;

		// split the source format string
		$formatItems = preg_split("/[ \/\-,.:]+/", $sourceFormat);

		// check for unsupported chars
		foreach ( $transform as $key => $value ):
			if (( strlen( trim( $value )) == 0 )
			and ( in_array( $key, $formatItems ) == TRUE )):
				$sourceFormat = $defaultFormat;
				break;
			endif;
		endforeach;

		// do the transformation
		// source: http://stackoverflow.com/questions/16702398/convert-a-php-date-format-to-a-jqueryui-datepicker-date-format
		$targetFormat = '';
		$escaping = FALSE;
		for ( $i = 0; $i < strlen( $sourceFormat ); $i++ ):
			$char = $sourceFormat[$i];
			if ( $char === '\\' ): // PHP date format escaping character
				$i++;
				if ( $escaping == TRUE ):
					$targetFormat .= $sourceFormat[$i];
				else:
					$targetFormat .= '\'' . $sourceFormat[$i];
				endif;
				$escaping = TRUE;
			else:
				if ( $escaping == TRUE ):
					$targetFormat .= "'";
					$escaping = FALSE;
				endif;
				if ( isset( $transform[ $char ] ) == TRUE ):
					$targetFormat .= $transform[$char];
				else:
					$targetFormat .= $char;
				endif;
			endif;
		endfor;

		// return
		return $targetFormat;
	}
endif;

?>
