<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// define visibility modes
	$linker_visibilities = array();
	$linker_visibilities[]		= 'public';
	$linker_visibilities[]		= 'registered';
	$linker_visibilities[]		= 'none';

// define link types
	$linker_linktypes = array();
	$linker_linktypes[]		= 'link';	// link to external pages
	$linker_linktypes[]		= 'page';	// link to internal pages
	$linker_linktypes[]		= 'media';	// link to media files

// define kind of tree !! must be same in LINKER and in LINKER_VIEW !!!
	// type = (for page, folder)
		// trail = aaa, aaa/bbb, aaa/bbb/ccc, aaa/ddd, ...
		// level = aaa, -- bbb, ----ccc, --ddd, ...
		// array = array with page items, only available for pages
	// prefix = (for page, section, folder)
		// a string added in front of key for each item
/*
 * Note: The prefix on numeric keys is needed because of javascript handling
 * as it does not preserve numeric keys ...
 */
	$linker_treekind = array();
	$linker_treekind['page']['type']		= 'level';
	$linker_treekind['page']['prefix']		= 'P';
	$linker_treekind['page']['rootid']		= '0';
	$linker_treekind['page']['addroot']		= '0';
	$linker_treekind['section']['prefix']	= 'S';
	$linker_treekind['media']['type']		= 'level';
	$linker_treekind['media']['prefix']		= '';
	$linker_treekind['file']['prefix']		= '';

// start items in detail view in ..
	// 1 = collapsed
	// 0 = open
	$linker_startCollapsed['group'] = 1;
	$linker_startCollapsed['link']  = 1;
	$linker_startCollapsed['NEW']   = 0;	//do not collapse new entries

// set link type for new links
	$linker_newLinkType = 'link';

// provide a list of modules, which will be excluded from the section list
	$linker_disabledModules   = array();
	// example:
	//$linker_disabledModules[] = 'section_picker';

?>
