<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// set function path
	$functionPath = $linker_modulePath . '/lib/functions/';
	$functionPathCMS = LEPTON_PATH . '/framework/functions/';

// load function scripts based on current module script
	switch ( $linker_component ):
	case 'tool':
	case 'ajax.add_link':
		// add module reformatting text array
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.build_text_array.php' );
		// add module returning proper status
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.evaluate_status.php' );
		// add module returning page languages array
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.get_page_languages.php' );
		// add module for transforming date & time formats
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.transform_datetime_format.php' );
		// initialize page & folder tree generation
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.init_link_type.php' );
		// add page tree list generation

		break;

	case 'ajax.confirm_link':
		// add module returning proper status
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.evaluate_status.php' );

		break;

	case 'ajax.delete_row':
		// add module returning proper status
		$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.evaluate_status.php' );

		break;

	endswitch;

// add generic module for table access
	$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.execute_query.php' );

// add generic module for input filter
	$includes[]	= array( 'LOADER'=> 'require_once', 'FILE' => $functionPath . 'function.input_filter.php' );

?>
