<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/* infact, this function does not add a new link but returning an empty data set
 * to be provided into a TWIG template, which is then returned and added as empty row
 * into the tool_links.lte
 */

// initialize array for twig
	$pageTree			= array();
	$pageTreeSections	= array();
	$folderTree			= array();
	$folderTreeFiles	= array();

// load additional language file
	linker_load_language( $MOD_LINKER, $linker_languages, 'tool', FALSE );

// get list of possible parent groups
	$query = 'SELECT * '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' WHERE `parent` = 0'
			. ' ORDER BY `position`'
			;
	$tmp = linker_execute_query( __FUNCTION__, $query, 'get_all' );
	$parents = array();
	if ( count( $tmp ) > 0 ):
		foreach ( $tmp as $index => $item ):
			$parents[ $item[ 'link_id' ]] = $item[ 'group_name' ];
		endforeach;
	endif;

// get all page languages
	$pageLanguages = linker_get_page_languages();

// define text fields array
	$textFields = array( 'language', 'link_title', 'link_desc', 'link_ext', 'is_DB' );

// get details of a link row, doesn't matter which one ...
// we need just the fields ...
	$query = 'SELECT *, 1 AS is_DB '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' LIMIT 1'
			;
	$group = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );

// build empty rows by using parent as template and then make it empty ...
	$loop = $add_rows;	// defines number of empty lines to be added
	$i = 0;
	$tmp = $group;
	while ( $i < $loop ):
		$i++;

		foreach ( $tmp as $field => &$value ):
			$value = '';
		endforeach;

		// set defaults
		$tmp[ 'link_id' ]		= ( $row_counts + $i ) * -1;
		$tmp[ 'parent' ]		= $link_id;
		$tmp[ 'active' ]		= 1;
		$tmp[ 'is_DB' ]			= 0;
		$tmp[ 'status' ]		= 'UNDEFINED';
		$tmp[ 'valid_from' ]	= '';
		$tmp[ 'valid_till' ]	= '';
		$tmp[ 'link_type' ]		= $linker_newLinkType;
		$link_type_main = '';
		$link_type_detail = '';
		linker_init_link_type( $tmp[ 'link_type' ], $tmp[ 'link_url' ], '', $link_type_main, $link_type_detail );
		$tmp[ 'link_type_main' ]	= $link_type_main;
		$tmp[ 'link_type_detail' ]	= $link_type_detail;

		// add empty texts
		$tmp['TEXT'] = linker_build_text_array( $tmp, '', $textFields, $pageLanguages );

		// set is_DB = 0
		foreach ( $tmp['TEXT'] as $index => &$textItem ):
			$textItem[ 'is_DB' ] = 0;
		endforeach;

		// create data rows
		$data[ $row_counts + $i ] = $tmp;
	endwhile;

?>
