<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// initialize messages shown in dialog
	$messages = array();

// load additional language file
	linker_load_language( $MOD_LINKER, $linker_languages, 'tool', FALSE );

// dummy loop
	while ( 1 == 1 ):
		// set confirmation date & user, status might be changed later
		$query = 'UPDATE ' . TABLE_PREFIX . 'mod_linker'
				. ' SET '
				. '  `modified_by`			= ' . $admin->get_user_id()
				. ', `version_number`		= `version_number` + 1'
				. ', `last_confirmed_when`	= CURRENT_TIMESTAMP'
				. ', `last_confirmed_by`	= ' . $admin->get_user_id()
				. ' WHERE `link_id` = ' . $link_id
				;
		$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
		if ( $status == FALSE ):
			$messages[ 'ERROR' ][] = $MOD_LINKER[ 'ERROR' ][ 'fail' ];
			break;
		endif;

		// get current link data
		$query = 'SELECT * '
				. ' FROM ' . TABLE_PREFIX . 'mod_linker'
				. ' WHERE `link_id` = ' . $link_id
				;
		$data = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );
		if ( count( $data ) == 0 ):
			$messages[ 'ERROR' ][] = $MOD_LINKER[ 'ERROR' ][ 'nodata' ];
			break;
		endif;

		// evaluate new status
		$newStatus = linker_evaluate_status( $data );

		// update status when needed
		if ( $data['status'] != $newStatus ):
			// update status in array for further processing
			$data['status'] = $newStatus;

			$query = 'UPDATE ' . TABLE_PREFIX . 'mod_linker'
					. ' SET '
					. '  `status`			= "' . $data['status'] . '"'
					. ' WHERE `link_id` = ' . $link_id
					;
			$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
			if ( $status == FALSE ):
				$messages[ 'ERROR' ][] = $MOD_LINKER[ 'ERROR' ][ 'fail' ];
				break;
			endif;
		endif;

		// show success
		$messages[ 'INFO' ][] = $MOD_LINKER[ 'INFO' ][ 'success' ];

		// show message when link is inactive
		if ( $data[ 'active' ] == 0 ):
			$messages[ 'WARNING' ][] = $MOD_LINKER[ 'WARNING' ][ 'inactive' ];
		endif;

		// show message when link has reached valid till date
		if (( strlen( trim( $data[ 'valid_till' ] ))	>  0     )
		and ( $data[ 'valid_till' ]						>  0     )
		and ( strtotime( $data[ 'valid_till' ] )		< time() )):
			$messages[ 'WARNING' ][] = $MOD_LINKER[ 'WARNING' ][ 'valid_till' ];
		endif;

		// show message when status is not OK
		if ( $data[ 'status' ] != 'OK' ):
			$messages[ 'WARNING' ][] = $MOD_LINKER[ 'TIP' ][ $data[ 'status' ] ];
		endif;

		// break dummy loop in any case
		break;
	endwhile;

	if ( count( $data ) > 0 ):
		// add confirmed user name
		$tmp = $admin->get_user_details( $data['last_confirmed_by'] );
		$data[ 'last_confirmed_by_name' ] = $tmp['display_name'];

		// add status image info
		$data['status_src']   = LEPTON_URL . '/modules/linker/css/images/status_' . strtolower( $data[ 'status' ] ) . '_16.png';
		$data['status_alt']   = $MOD_LINKER['TIP'][ $data[ 'status' ]];
		$data['status_title'] = $MOD_LINKER['TIP'][ $data[ 'status' ]];

		// add confirm image info
		if (( $data[ 'status' ] == 'OK' )
		 or ( $data[ 'status' ] == 'WARNING' )):
			$data['confirm_src']   = THEME_URL . '/images/ok_16.png';
			$data['confirm_alt']   = $MOD_LINKER['TIP'][ 'confirmed_link' ];
			$data['confirm_title'] = $MOD_LINKER['TIP'][ 'confirmed_link' ];
		elseif ( $data[ 'status' ] == 'DELETED' ):
			$data['confirm_src']   = THEME_URL . '/images/warning_16.png';
			$data['confirm_alt']   = $MOD_LINKER['TIP'][ 'deleted_link' ];
			$data['confirm_title'] = $MOD_LINKER['TIP'][ 'deleted_link' ];
		else:
			$data['confirm_src']   = THEME_URL . '/images/warning_16.png';
			$data['confirm_alt']   = $MOD_LINKER['TIP'][ 'confirm_link' ];
			$data['confirm_title'] = $MOD_LINKER['TIP'][ 'confirm_link' ];
		endif;
	endif;

?>
