<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// initialize array for twig
	$data = array();

// prepare SQL
	$query = 'SELECT * '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' WHERE `parent` = 0'
			. ' ORDER BY `position`'
			;

// get the data
	$groups = linker_execute_query( __FUNCTION__, $query, 'get_all' );

// loop over links
	if ( count( $groups ) > 0 ):
		foreach ( $groups as $index => $group ):
			// get group name
			$group_name = $group[ 'group_name' ];

			// read links
			$query = 'SELECT * '
					. ' FROM ' . TABLE_PREFIX . 'mod_linker'
					. ' WHERE `parent` = ' . $group[ 'link_id' ]
					. ' ORDER BY `position`'
					;
			$links = linker_execute_query( __FUNCTION__, $query, 'get_all' );

			// initialize link details
			$items = array();
			$items[ 'link_id' ]			= $group[ 'link_id' ];
			$items[ 'group_collection' ]= $group[ 'group_collection' ];
			$items[ 'active' ]			= $group[ 'active' ];
			$items[ 'status' ]			= $group[ 'status' ];
			$items[ 'count' ]			= 0;
			$items[ 'status_OK' ]		= 0;
			$items[ 'status_WARNING' ]	= 0;
			$items[ 'status_ENDVALID' ]	= 0;
			$items[ 'not_confirmed' ]	= 0;
			$items[ 'oldest_confirmed' ]= '';
			$items[ 'visibility' ]		= $group[ 'visibility' ];

			// add items with life
			if ( count( $links ) > 0 ):
				foreach ( $links as $index => $link ):

					// evaluate new status
					if ( $link[ 'status' ] == 'DELETED' ):
						// count deleted as endvalidated
						$link[ 'status' ] = 'ENDVALID';
					else:
						$link[ 'status' ] = linker_evaluate_status( $link );
					endif;

					// set twig values per group
					$items[ 'count' ] += 1;
					if ( array_key_exists( 'status_' . $link[ 'status' ], $items ) == TRUE ):
						$items[ 'status_' . $link[ 'status' ]] += 1;
					endif;
					if (( $items[ 'oldest_confirmed' ]	== '' )
					 or (( strlen( trim( $link[ 'last_confirmed_when' ] )) > 0 )
					 and ( $items[ 'oldest_confirmed' ]	>  $link[ 'last_confirmed_when' ] ))):
						$items[ 'oldest_confirmed' ] = $link[ 'last_confirmed_when' ];
					endif;
					if ( $link[ 'last_confirmed_when' ] == '' ):
						$items[ 'not_confirmed' ] += 1;
					endif;
				endforeach;
			endif;

			// save items per group
			$data[ $group_name ] = $items;
		endforeach;
	endif;

?>
