<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// initialize array for twig
	$data				= array();
	$pageTree			= array();
	$pageTreeSections	= array();
	$folderTree			= array();
	$folderTreeFiles	= array();

// get list of possible parent groups
	$query = 'SELECT * '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' WHERE `parent` = 0'
			. ' ORDER BY `position`'
			;
	$tmp = linker_execute_query( __FUNCTION__, $query, 'get_all' );
	$parents = array();
	if ( count( $tmp ) > 0 ):
		foreach ( $tmp as $index => $item ):
			$parents[ $item[ 'link_id' ]] = $item[ 'group_name' ];
		endforeach;
	endif;

// get all page languages
	$pageLanguages = linker_get_page_languages();

// define text fields array
	$textFields = array( 'language', 'link_title', 'link_desc', 'link_ext', 'is_DB', 'version_number' );

// get details of current group
	$query = 'SELECT *, 1 AS is_DB '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' WHERE `link_id` = ' . $link_id
			;
	$group = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );

	// read group texts
	// build text fields even if no group data found.
	$query = 'SELECT *, 1 AS is_DB '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker_text'
			. ' WHERE `link_id` = ' . $link_id
			;
	$group['TEXT'] = linker_build_text_array( $group, $query, $textFields, $pageLanguages );

// get all links of current group
	$query = 'SELECT *, 1 AS is_DB '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker'
			. ' WHERE `parent` = ' . $link_id
			. ' ORDER BY `position`'
			;
	$tmp = linker_execute_query( __FUNCTION__, $query, 'get_all' );

// loop over available links
	if ( count( $tmp ) > 0 ):
		// initialize user array
		$users = array();
		// data loop
		foreach ( $tmp as $index => $link ):
			// evaluate new status
			$link[ 'status' ] = linker_evaluate_status( $link );

			// check link_type
			$link_type_main = '';
			$link_type_detail = '';
			linker_init_link_type( $link[ 'link_type' ], $link[ 'link_url' ], '', $link_type_main, $link_type_detail );
			$link[ 'link_type_main' ]	= $link_type_main;
			$link[ 'link_type_detail' ]	= $link_type_detail;

			// check for valid from/till
			if (( $link[ 'valid_from' ] == 0  )
			 or ( $link[ 'valid_from' ] == '' )):
				$link[ 'valid_from' ] = '';
			else:
				$link[ 'valid_from' ] = date( DATE_FORMAT, $link[ 'valid_from' ] );
			endif;
			if (( $link[ 'valid_till' ] == 0 )
			 or ( $link[ 'valid_till' ] == '' )):
				$link[ 'valid_till' ] = '';
			else:
				$link[ 'valid_till' ] = date( DATE_FORMAT, $link[ 'valid_till' ] );
			endif;

			// get user name of last_confirmed_by
			if ( $link[ 'last_confirmed_by' ] > 0 ):
				$userId = $link[ 'last_confirmed_by' ];
				if ( array_key_exists( $userId, $users ) == FALSE ):
					$users[ $userId ] = $admin->get_user_details( $userId );
				endif;
				$link[ 'last_confirmed_by_name' ] = $users[ $userId ]['display_name'];
			else:
				$link[ 'last_confirmed_by_name' ] = '';
			endif;

			// read texts
			$query = 'SELECT *, 1 as is_DB '
					. ' FROM ' . TABLE_PREFIX . 'mod_linker_text'
					. ' WHERE `link_id` = ' . $link[ 'link_id' ]
					;
			$link['TEXT'] = linker_build_text_array( $link, $query, $textFields, $pageLanguages );

			// create data rows
			$data[ $link[ 'position' ] ] = $link;
		endforeach;

// build empty rows by using parent as template and then make it empty ...
	else:
		$loop = 1;	// defines number of empty lines
		$i = 0;
		$tmp = $group;
		while ( $i < $loop ):
			$i++;

			foreach ( $tmp as $field => $value ):
				$value = '';
			endforeach;

			// set defaults
			$tmp[ 'link_id' ]		= $i * -1;
			$tmp[ 'parent' ]		= $link_id;
			$tmp[ 'group_name' ]	= $group[ 'group_name' ];
			$tmp[ 'active' ]		= 1;
			$tmp[ 'is_DB' ]			= 0;
			$tmp[ 'status' ]		= 'UNDEFINED';
			$tmp[ 'valid_from' ]	= '';
			$tmp[ 'valid_till' ]	= '';
			$tmp[ 'link_type' ]		= $linker_newLinkType;
			$link_type_main = '';
			$link_type_detail = '';
			linker_init_link_type( $tmp[ 'link_type' ], $tmp[ 'link_url' ], '', $link_type_main, $link_type_detail );
			$tmp[ 'link_type_main' ]	= $link_type_main;
			$tmp[ 'link_type_detail' ]	= $link_type_detail;

			// add empty texts
			$tmp['TEXT'] = linker_build_text_array( $tmp, '', $textFields, $pageLanguages );

			// create data rows
			$data[ $i ] = $tmp;
		endwhile;
	endif;

?>
