<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// validate input
	if ( strlen( trim( $group_name )) > 0 ):
		// check if this group is already saved
		$query = 'SELECT COUNT(`group_name`)'
				. ' FROM ' . TABLE_PREFIX . 'mod_linker'
				. ' WHERE LOWER(`group_name`) = "' . mb_convert_case( $group_name, MB_CASE_LOWER, 'UTF-8' ) . '"'
				. '   AND `parent`           = 0'
				;
		$data = linker_execute_query( __FUNCTION__, $query, 'get_one' );
		if ( $data > 0 ):
			// group already exists
			$status = FALSE;
			$linker_status = $MOD_LINKER['addgroup']['exists'];
		else:
			// group not exists
			$status = TRUE;
		endif;
	else:
		// group can not be empty
		$status = FALSE;
		$linker_status = $MOD_LINKER['addgroup']['empty'];
	endif;

// prepare SQL
	if ( $status == TRUE ):
		// get max position
		$query = 'SELECT MAX(`position`) '
				. ' FROM ' . TABLE_PREFIX . 'mod_linker'
				. ' WHERE `parent` = 0'
				;
		$maxPos = 1 + max( 0, linker_execute_query( __FUNCTION__, $query, 'get_one' ));

		// do insert
		$query = 'INSERT INTO ' . TABLE_PREFIX . 'mod_linker '
							.'('
							. '  `created_when`'
							. ', `modified_by`'
							. ', `active`'
							. ', `parent`'
							. ', `position`'
							. ( isset( $group_name )		== TRUE ? ', `group_name`'		: '' )
							. ', `confirmation_age_warning`'
							. ', `confirmation_age_endvalid`'
							. ')'
						. ' VALUES '
							. '('
							. '  CURRENT_TIMESTAMP'
							. ', ' . $admin->get_user_id()
							. ', 1'
							. ', 0'
							. ', ' . $maxPos
							. ( isset( $group_name )		== TRUE ? ', "' . $group_name . '"'		: '' )
							. ', ' . ( isset( $linker_confirmation_age_warning )	== TRUE ? $linker_confirmation_age_warning 	: '0' )
							. ', ' . ( isset( $linker_confirmation_age_endvalid )	== TRUE ? $linker_confirmation_age_endvalid	: '0' )
							. ')';

	// do automatic update if duplicate on a unique key occurs
	// see: http://dev.mysql.com/doc/refman/5.0/en/insert-on-duplicate.html
		$query .= ' ON DUPLICATE KEY UPDATE '
					. '  `modified_by`		= ' . $admin->get_user_id()
					. ', `version_number`	= `version_number` + 1'
					. ', `parent`			= 0'
					. ( isset( $group_name )		== TRUE ? ', `group_name`'		. '= "' . $group_name . '"'		: '' )
				;

	// do the update!
		$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
	endif;

?>
