<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// validate input
	if ( count( $data ) > 0 ):
		$status = TRUE;
		// get all page languages
		$pageLanguages = linker_get_page_languages();

	else:
		// data can not be empty
		$status = FALSE;
		$linker_status = $MOD_LINKER['savelinks']['nodata'];
	endif;

// initialize vars
	$linkText = array();


// first save group
	$doGroupUpdate = FALSE;
	if (( $status == TRUE )
	and ( array_key_exists( 'LINK', $data ) == TRUE )):
		// get group element in a dummy loop
		while ( array_key_exists( $link_id, $data[ 'LINK' ] ) == TRUE ):
			// get existing row
			$query = 'SELECT * '
					. ' FROM ' . TABLE_PREFIX . 'mod_linker '
					. ' WHERE `link_id` = ' . $link_id
					;
			$origin = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );
			if ( count( $origin ) == 0 ):
				// no group data found should normally not happen ...
				$status = FALSE;
				break;
			endif;

			// get save data set
			$linkItems = $data[ 'LINK' ][ $link_id ];

			// group name must be present
			if ( array_key_exists( 'group_name', $linkItems )	== FALSE ):
				$status = FALSE;
				$linker_status = $MOD_LINKER['savelinks']['group_name'];
				break;	// foreach
			endif;

			// has version changed ?
			if (( array_key_exists( 'parent', $linkItems )		== TRUE  )
			and ( $linkItems[ 'version' ] == $origin[ 'version_number' ] )):
				// no update needed
				break;
			endif;

			// update group data
			$query = 'UPDATE ' . TABLE_PREFIX . 'mod_linker '
					. ' SET '
					. '  `modified_by`		= ' . $admin->get_user_id()
					. ', `version_number`	= `version_number` + 1'
					. ', `parent` 			=  0'
					. ', `status` 			= "UNDEFINED"'
					. ', `group_collection` = "' . $linkItems[ 'group_collection' ] . '"'
					. ', `group_name` 		= "' . $linkItems[ 'group_name' ] . '"'
					. ', `link_code` 		= ""'
					. ', `link_type` 		= ""'
					. ', `link_url` 		= ""'
					. ', `valid_from` 		= ""'
					. ', `valid_till` 		= ""'
					. ', `confirmation_age_warning` 	= ' . ( isset( $linkItems[ 'confirmation_age_warning' ] )	== TRUE ? $linkItems[ 'confirmation_age_warning' ]	: '0' )
					. ', `confirmation_age_endvalid`	= ' . ( isset( $linkItems[ 'confirmation_age_endvalid' ] )	== TRUE ? $linkItems[ 'confirmation_age_endvalid' ]	: '0' )
					. ', `visibility` 					= "' . ( isset( $linkItems[ 'visibility' ] )				== TRUE ? $linkItems[ 'visibility' ]	: 'public' ) . '"'
					. ', `release_code` 				= "' . ( isset( $linkItems[ 'release_code' ] )				== TRUE ? $linkItems[ 'release_code' ]	: '' ) . '"'
					. ' WHERE `link_id` = ' . $link_id
					;
			$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
			if ( $status == FALSE ):
				break;
			endif;

			// when group has been updated, also childs will be updated
			$doGroupUpdate = TRUE;


			// Update/insert the text
			foreach ( $pageLanguages as $language ):
				// get existing row
				$query = 'SELECT * '
						. ' FROM ' . TABLE_PREFIX . 'mod_linker_text '
						. ' WHERE `link_id`		= ' . $link_id
						. '   AND `language`	= "' . $language . '"'
						;
				$origin = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );

				if (( array_key_exists( 'TEXT', $data )			  == TRUE )
				and ( array_key_exists( $link_id, $data['TEXT'] ) == TRUE )):
					$textItems = $data[ 'TEXT' ][ $link_id ];
				elseif ( count( $origin ) > 0 ):
					// when TEXT is missing we assume it is from DB to have DB row deleted if exists
					$textItems = array( $language . '-is_DB' => 1 );
				else:
					// no data saved and no data passed
					continue;
				endif;

				// anything changed ?
				if (( array_key_exists( $language . '-version', $textItems ) == TRUE )
				and ( count( $origin ) > 0 )
				and ( $textItems[ $language . '-version' ] == $origin[ 'version_number' ] )):
					// nothing changed
					continue;
				endif;

				// save text items for save below
				$textItems[ 'link_type' ] = '';
				$linkText[ $link_id ][ $language ] = $textItems;
			endforeach;

			// always end while
			break;
		endwhile;
	endif;


// get existing group data
	$query = 'SELECT * '
			. ' FROM ' . TABLE_PREFIX . 'mod_linker '
			. ' WHERE `parent` = 0'
			;
	$tmp = linker_execute_query( __FUNCTION__, $query, 'get_all' );
	$parents = array();
	if ( count( $tmp ) > 0 ):
		foreach ( $tmp as $index => $item ):
			$parents[ $item[ 'link_id' ]] = $item;
		endforeach;
	endif;

// Save links
	// loop over all input links
	// when is_DB >0, then update / else insert
	if (( $status == TRUE )
	and ( array_key_exists( 'LINK', $data ) == TRUE )):
		foreach ( $data[ 'LINK' ] as $linkId => $linkItems ):

			// ignore group links
			if ( $linkItems[ 'parent' ] == 0 ):
				continue;
			endif;

			// get existing row
			$query = 'SELECT * '
					. ' FROM ' . TABLE_PREFIX . 'mod_linker '
					. ' WHERE `link_id` = ' . $linkId
					;
			$origin = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );

			// manipulate input stream based due to values set by ajax
			if ( count( $origin ) > 0 ):
				if ( $linkItems[ 'is_DB' ] != 1 ):
					$linkItems[ 'is_DB' ] = 1;
				endif;

			else:
				$origin = array();
				$origin[ 'version_number' ]			= '0';
				$origin[ 'parent' ]					= '';
				$origin[ 'active' ]					= '1';
				$origin[ 'last_confirmed_when' ]	= '0';
				$origin[ 'last_confirmed_by' ]		= '';
				$origin[ 'status' ] 				= 'UNDEFINED';

				if ( $linkItems[ 'is_DB' ] != 0 ):
					$linkItems[ 'is_DB' ] = 0;
				endif;
			endif;

			$linkItems[ 'active' ]				= $origin[ 'active' ];
			$linkItems[ 'status' ]				= $origin[ 'status' ];
			$linkItems[ 'last_confirmed_when' ]	= $origin[ 'last_confirmed_when' ];
			$linkItems[ 'last_confirmed_by' ]	= $origin[ 'last_confirmed_by' ];

			// has version changed ?
			if (( array_key_exists( 'version', $linkItems )		== TRUE    )
			and ( $linkItems[ 'version' ]	== $origin[ 'version_number' ] )
			and ( $doGroupUpdate 			== FALSE                       )):
				// no update needed, get next
				continue;
			endif;

			// inherit details from parent
			if ( array_key_exists( 'parent', $linkItems ) == FALSE ):
				// should never happen. But if then ignore
				continue;
			endif;
			$linkItems[ 'group_name' ]					= $parents[ $linkItems[ 'parent' ] ][ 'group_name' ];
			$linkItems[ 'confirmation_age_warning' ]	= $parents[ $linkItems[ 'parent' ] ][ 'confirmation_age_warning' ];
			$linkItems[ 'confirmation_age_endvalid' ]	= $parents[ $linkItems[ 'parent' ] ][ 'confirmation_age_endvalid' ];
			$linkItems[ 'visibility' ]					= $parents[ $linkItems[ 'parent' ] ][ 'visibility' ];

			if (( $linkItems[ 'parent' ] != $origin[ 'parent' ] )
			 or ( $linkItems[ 'is_DB' ] == 0 )):
				// get max position id for new items
				$query = 'SELECT MAX(`position`) '
						. ' FROM ' . TABLE_PREFIX . 'mod_linker'
						. ' WHERE `parent` = ' . $linkItems[ 'parent' ]
						;
				$linkItems[ 'position' ] = 1 + max( 0, linker_execute_query( __FUNCTION__, $query, 'get_one' ));
			endif;

			// convert valid from/till
			if ( array_key_exists( 'valid_from', $linkItems ) == TRUE ):
				$linkItems[ 'valid_from' ] = strtotime( $linkItems[ 'valid_from' ] );
			else:
				$linkItems[ 'valid_from' ] = 0;
			endif;
			if ( array_key_exists( 'valid_till', $linkItems ) == TRUE ):
				$linkItems[ 'valid_till' ] = strtotime( $linkItems[ 'valid_till' ] );
			else:
				$linkItems[ 'valid_till' ] = 0;
			endif;

			// status to be set regardless what is passed
			if ( $linkItems[ 'is_DB' ] == 1 ):
				$linkItems[ 'status' ] = linker_evaluate_status( $linkItems );
			endif;


			// handle link_type values
			if ( array_key_exists( 'link_type', $linkItems ) == FALSE ):
				$linkItems[ 'link_type' ] = 'link';
			endif;

			switch ( $linkItems[ 'link_type' ] ):
			case 'link':
				// nothing to be done
				break;

			case 'media':
				if (( array_key_exists( 'link_type_main', $linkItems ) == TRUE )
				and ( strlen( $linkItems[ 'link_type_main' ] ) > 0 )):
					$linkItems[ 'link_url' ] = $linkItems[ 'link_type_main' ];
					if (( array_key_exists( 'link_type_detail', $linkItems ) == TRUE )
					and ( strlen( $linkItems[ 'link_type_detail' ] ) > 0 )):
						$linkItems[ 'link_url' ] .= $linkItems[ 'link_type_detail' ];
					else:
						// a folder alone is not valid
						$linkItems[ 'link_url' ] = '';
					endif;
				else:
					$linkItems[ 'link_url' ] = '';
				endif;
				break;

			case 'page':
				if (( array_key_exists( 'link_type_main', $linkItems ) == TRUE )
				and ( strlen( $linkItems[ 'link_type_main' ] ) > 0 )):
					$linkItems[ 'link_url' ] = $linkItems[ 'link_type_main' ];
					if (( array_key_exists( 'link_type_detail', $linkItems ) == TRUE )
					and ( strlen( $linkItems[ 'link_type_detail' ] ) > 0 )):
						$linkItems[ 'link_url' ] .= ', ' . $linkItems[ 'link_type_detail' ];
					// else:
						// a page without a section is allowed
					endif;
				else:
					$linkItems[ 'link_url' ] = '';
				endif;
				break;

			default:
				// set default
				$linkItems[ 'link_type' ] = 'link';
				$linkItems[ 'link_url' ]  = '';
				break;

			endswitch;

			// check if some data are set so creation/update is needed
			// group_name only is no reason to save ....
			$fields = array( 'link_code' => '', 'link_url' => '' );
			// array_diff_key return all items of $fields not found in $linkItems
			if ( count( array_diff_key( $fields, $linkItems )) == count( $fields ) ):
				// check if also TEXT fields are empty
				$texts = 0;
				if (( array_key_exists( 'TEXT', $data )			 == TRUE )
				and ( array_key_exists( $linkId, $data['TEXT'] ) == TRUE )):
					foreach ( $pageLanguages as $language ):
						$fields = array( $language . '-link_title' => '', $language . '-link_desc' => '', $language . '-link_ext' => '', $language . '-link_type_main' => '', $language . '-link_type_detail' => '' );
						if ( count( array_diff_key( $fields, $data['TEXT'][$linkId] )) != count( $fields ) ):
							// at least one valuable field is set
							$texts++;
						endif;
					endforeach;
				endif;
				// neither link nor text data found
				if ( $texts == 0 ):
					if ( $linkItems[ 'is_DB' ] == 1 ):
						// set status = DELETED, do update
						$linkItems[ 'status' ] = 'DELETED';
					else:
						// do not process empty rows not already saved in DB
						// read next link
						continue;
					endif;
				endif;
			endif;


		// build sql
			$query = '';
			if ( $linkItems[ 'is_DB' ] == 1 ):
				$query = 'UPDATE ' . TABLE_PREFIX . 'mod_linker '
						. ' SET '
						. '  `modified_by`		= ' . $admin->get_user_id()
						. ', `version_number`	= `version_number` + 1'
						. ( isset( $linkItems[ 'parent' ] )						== TRUE ? ', `parent`						= "' . $linkItems[ 'parent' ] . '"'						: '' )
						. ( isset( $linkItems[ 'status' ] )						== TRUE ? ', `status`						= "' . $linkItems[ 'status' ] . '"'						: '' )
						. ( isset( $linkItems[ 'position' ] )					== TRUE ? ', `position`						= "' . $linkItems[ 'position' ] . '"'					: '' )
						. ( isset( $linkItems[ 'group_name' ] )					== TRUE ? ', `group_name`					= "' . $linkItems[ 'group_name' ] . '"'					: '' )
						. ( isset( $linkItems[ 'link_code' ] )					== TRUE ? ', `link_code`					= "' . $linkItems[ 'link_code' ] . '"'					: '' )
						. ( isset( $linkItems[ 'link_type' ] )					== TRUE ? ', `link_type`					= "' . $linkItems[ 'link_type' ] . '"'					: '' )
						. ( isset( $linkItems[ 'link_url' ] )					== TRUE ? ', `link_url`						= "' . $linkItems[ 'link_url' ] . '"'					: '' )
						. ( isset( $linkItems[ 'valid_from' ] )					== TRUE ? ', `valid_from`					= "' . $linkItems[ 'valid_from' ] . '"'					: '' )
						. ( isset( $linkItems[ 'valid_till' ] )					== TRUE ? ', `valid_till`					= "' . $linkItems[ 'valid_till' ] . '"'					: '' )
						. ( isset( $linkItems[ 'confirmation_age_warning' ] )	== TRUE ? ', `confirmation_age_warning`		= "' . $linkItems[ 'confirmation_age_warning' ] . '"'	: '' )
						. ( isset( $linkItems[ 'confirmation_age_endvalid' ] )	== TRUE ? ', `confirmation_age_endvalid`	= "' . $linkItems[ 'confirmation_age_endvalid' ] . '"'	: '' )
						. ( isset( $linkItems[ 'visibility' ] )					== TRUE ? ', `visibility`					= "' . $linkItems[ 'visibility' ] . '"'					: '' )
						. ( isset( $linkItems[ 'release_code' ] )				== TRUE ? ', `release_code`					= "' . $linkItems[ 'release_code' ] . '"'				: '' )
						. ' WHERE `link_id` = ' . $linkId
						;
			else:
				// do insert
				$query = 'INSERT INTO ' . TABLE_PREFIX . 'mod_linker '
						.'('
						. '  `created_when`'
						. ', `modified_by`'
						. ( isset( $linkItems[ 'active' ] )						== TRUE ? ', `active`'		: '' )
						. ( isset( $linkItems[ 'parent' ] )						== TRUE ? ', `parent`'		: '' )
						. ( isset( $linkItems[ 'position' ] )					== TRUE ? ', `position`'	: '' )
						. ( isset( $linkItems[ 'status' ] )						== TRUE ? ', `status`'		: '' )
						. ( isset( $linkItems[ 'group_name' ] )					== TRUE ? ', `group_name`'	: '' )
						. ( isset( $linkItems[ 'link_code' ] )					== TRUE ? ', `link_code`'	: '' )
						. ( isset( $linkItems[ 'link_type' ] )					== TRUE ? ', `link_type`'	: '' )
						. ( isset( $linkItems[ 'link_url' ] )					== TRUE ? ', `link_url`'	: '' )
						. ( isset( $linkItems[ 'valid_from' ] )					== TRUE ? ', `valid_from`'	: '' )
						. ( isset( $linkItems[ 'valid_till' ] )					== TRUE ? ', `valid_till`'	: '' )
						. ( isset( $linkItems[ 'confirmation_age_warning' ] )	== TRUE ? ', `confirmation_age_warning`'	: '' )
						. ( isset( $linkItems[ 'confirmation_age_endvalid' ] )	== TRUE ? ', `confirmation_age_endvalid`'	: '' )
						. ( isset( $linkItems[ 'visibility' ] )					== TRUE ? ', `visibility`'	: '' )
						. ( isset( $linkItems[ 'release_code' ] )				== TRUE ? ', `release_code`'	: '' )
						. ')'
					. ' VALUES '
						. '('
						. '  CURRENT_TIMESTAMP'
						. ', ' . $admin->get_user_id()
						. ( isset( $linkItems[ 'active' ] )						== TRUE ? ', "' . $linkItems[ 'active' ] . '"'		: '' )
						. ( isset( $linkItems[ 'parent' ] )						== TRUE ? ', "' . $linkItems[ 'parent' ] . '"'		: '' )
						. ( isset( $linkItems[ 'position' ] )					== TRUE ? ', "' . $linkItems[ 'position' ] . '"'	: '' )
						. ( isset( $linkItems[ 'status' ] )						== TRUE ? ', "' . $linkItems[ 'status' ] . '"'		: '' )
						. ( isset( $linkItems[ 'group_name' ] )					== TRUE ? ', "' . $linkItems[ 'group_name' ] . '"'	: '' )
						. ( isset( $linkItems[ 'link_code' ] )					== TRUE ? ', "' . $linkItems[ 'link_code' ] . '"'	: '' )
						. ( isset( $linkItems[ 'link_type' ] )					== TRUE ? ', "' . $linkItems[ 'link_type' ] . '"'	: '' )
						. ( isset( $linkItems[ 'link_url' ] )					== TRUE ? ', "' . $linkItems[ 'link_url' ] . '"'	: '' )
						. ( isset( $linkItems[ 'valid_from' ] )					== TRUE ? ', "' . $linkItems[ 'valid_from' ] . '"'	: '' )
						. ( isset( $linkItems[ 'valid_till' ] )					== TRUE ? ', "' . $linkItems[ 'valid_till' ] . '"'	: '' )
						. ( isset( $linkItems[ 'confirmation_age_warning' ] )	== TRUE ? ',  ' . $linkItems[ 'confirmation_age_warning' ]	: '' )
						. ( isset( $linkItems[ 'confirmation_age_endvalid' ] )	== TRUE ? ',  ' . $linkItems[ 'confirmation_age_endvalid' ]	: '' )
						. ( isset( $linkItems[ 'visibility' ] )					== TRUE ? ', "' . $linkItems[ 'visibility' ] . '"'			: '' )
						. ( isset( $linkItems[ 'release_code' ] )				== TRUE ? ', "' . $linkItems[ 'release_code' ] . '"'		: '' )
						. ')';
			endif;

		// do the link insert/update!
			$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
			if ( $status == FALSE ):
				break;
			endif;

		// get last created link_id from autoincrement
			if ( $linkItems[ 'is_DB' ] == 1 ):
				$textId = $linkId;
			else:
				$query =  'SELECT LAST_INSERT_ID()';
				$textId = linker_execute_query( __FUNCTION__, $query, 'get_one' );
			endif;

			// Update/insert the text
			foreach ( $pageLanguages as $language ):
				// get existing row
				$query = 'SELECT * '
						. ' FROM ' . TABLE_PREFIX . 'mod_linker_text '
						. ' WHERE `link_id`		= ' . $textId
						. '   AND `language`	= "' . $language . '"'
						;
				$origin = linker_execute_query( __FUNCTION__, $query, 'get_all_one' );

				if (( array_key_exists( 'TEXT', $data )			 == TRUE )
				and ( array_key_exists( $linkId, $data['TEXT'] ) == TRUE )):
					$textItems = $data[ 'TEXT' ][ $linkId ];
				elseif ( count( $origin ) > 0 ):
					// when TEXT is missing we assume it is from DB to have DB row deleted if exists
					$textItems = array( $language . '-is_DB' => 1 );
				else:
					// no data saved and no data passed
					continue;
				endif;

				// anything changed ?
				if (( array_key_exists( $language . '-version', $textItems ) == TRUE )
				and ( count( $origin ) > 0 )
				and ( $textItems[ $language . '-version' ] == $origin[ 'version_number' ] )):
					// nothing changed
					continue;
				endif;

				// save text items for save below
				$textItems[ 'link_type' ] = $linkItems[ 'link_type' ];
				$linkText[ $textId ][ $language ] = $textItems;
			endforeach;	// language
		endforeach;	// link
	endif;


// Update/insert the text
	if (( $status == TRUE )
	and ( count( $linkText ) > 0 )):
		foreach ( $linkText as $linkId => $languages ):
			foreach ( $languages as $language => $textItems ):
				// when all text fields are empty, delete text row if exists on DB
				$fields = array( $language . '-link_title' => '', $language . '-link_desc' => '', $language . '-link_ext' => '', $language . '-link_type_main' => '', $language . '-link_type_detail' => '' );
				if ( count( array_diff_key( $fields, $textItems )) == count( $fields ) ):
					if ( $textItems[ $language . '-is_DB' ] == 1 ):
						$query = 'DELETE FROM ' . TABLE_PREFIX . 'mod_linker_text '
								. ' WHERE `link_id`		= ' . $linkId
								. '   AND `language`	= "' . $language . '"'
								;
					else:
						// do not process empty rows not already saved in DB
						// read next text/language
						continue;
					endif;

				// otherwise insert/update
				else:
					// handle link_type values
					switch ( $textItems[ 'link_type' ] ):
					case 'media':
						if (( array_key_exists( $language . '-link_type_main', $textItems ) == TRUE )
						and ( strlen( $textItems[ $language . '-link_type_main' ] ) > 0 )):
							$textItems[ $language . '-link_ext' ] = $textItems[ $language . '-link_type_main' ];
							if (( array_key_exists( $language . '-link_type_detail', $textItems ) == TRUE )
							and ( strlen( $textItems[ $language . '-link_type_detail' ] ) > 0 )):
								$textItems[ $language . '-link_ext' ] .= $textItems[ $language . '-link_type_detail' ];
							else:
								// a folder allone is not valid
								$textItems[ $language . '-link_ext' ] = '';
							endif;
						else:
							$textItems[ $language . '-link_ext' ] = '';
						endif;
						break;

					case 'page':
						if (( array_key_exists( $language . '-link_type_main', $textItems ) == TRUE )
						and ( strlen( $textItems[ $language . '-link_type_main' ] ) > 0 )):
							$textItems[ $language . '-link_ext' ] = $textItems[ $language . '-link_type_main' ];
							if (( array_key_exists( $language . '-link_type_detail', $textItems ) == TRUE )
							and ( strlen( $textItems[ $language . '-link_type_detail' ] ) > 0 )):
								$textItems[ $language . '-link_ext' ] .= ', ' . $textItems[ $language . '-link_type_detail' ];
							// else:
								// a page without a section is allowed
							endif;
						else:
							$textItems[ $language . '-link_ext' ] = '';
						endif;
						break;

					endswitch;

					// build query
					$query = 'INSERT INTO ' . TABLE_PREFIX . 'mod_linker_text '
							.'('
							. '  `link_id`'
							. ', `language`'
							. ', `created_when`'
							. ', `modified_by`'
							. ( isset( $textItems[ $language . '-link_title' ] )	== TRUE ? ', `link_title`'	: '' )
							. ( isset( $textItems[ $language . '-link_ext' ] )		== TRUE ? ', `link_ext`'	: '' )
							. ( isset( $textItems[ $language . '-link_desc' ] )		== TRUE ? ', `link_desc`'	: '' )
							. ')'
						. ' VALUES '
							. '('
							.    $linkId
							. ', "' . $language . '"'
							. ', CURRENT_TIMESTAMP'
							. ', ' . $admin->get_user_id()
							. ( isset( $textItems[ $language . '-link_title' ] )	== TRUE ? ', "' . $textItems[ $language . '-link_title' ] . '"'	: '' )
							. ( isset( $textItems[ $language . '-link_ext' ] )		== TRUE ? ', "' . $textItems[ $language . '-link_ext' ] . '"'	: '' )
							. ( isset( $textItems[ $language . '-link_desc' ] )		== TRUE ? ', "' . $textItems[ $language . '-link_desc' ] . '"'	: '' )
							. ')'
							;

				// do automatic update if duplicate on a unique key occurs
				// see: http://dev.mysql.com/doc/refman/5.0/en/insert-on-duplicate.html
					$query .= ' ON DUPLICATE KEY UPDATE '
							. '  `modified_by`		= ' . $admin->get_user_id()
							. ', `version_number`	= `version_number` + 1'
							. ( isset( $textItems[ $language . '-link_title' ] )	== TRUE ? ', `link_title`	= "' . $textItems[ $language . '-link_title' ] . '"'	: '' )
							. ( isset( $textItems[ $language . '-link_ext' ] )		== TRUE ? ', `link_ext`		= "' . $textItems[ $language . '-link_ext' ] . '"'		: '' )
							. ( isset( $textItems[ $language . '-link_desc' ] )		== TRUE ? ', `link_desc`	= "' . $textItems[ $language . '-link_desc' ] . '"'		: '' )
							;
				endif;

			// do the text insert/update/delete!
				$status = linker_execute_query( __FUNCTION__, $query, 'try_catch' );
				if ( $status == FALSE ):
					break;
				endif;
			endforeach;	// language
		endforeach;	// text
	endif;

?>
