<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


/*
 * Checks to be fullfilled before module can be installed
 * ======================================================
 *
 * Source: http://doc.lepton-cms.org/docu/english/home/addons/precheck.php.php
 *
 * Possible PRECHECK values are:
 *				LEPTON_VERSION / WB_VERSION
 *				PHP_VERSION
 *				PHP_EXTENSIONS
 *				PHP_SETTINGS
 *				WB_ADDONS
 *				CUSTOM_CHECKS
 *
 */

// LEPTON version

	$PRECHECK['LEPTON_VERSION'] = array( 'VERSION' => '2.2', 'OPERATOR' => '>=' );


// PHP Version

	$PRECHECK['PHP_VERSION'] = array( 'VERSION' => '5.6', 'OPERATOR' => '>=' );


// PHP Extensions
	// $PRECHECK['PHP_EXTENSIONS'] = array('gd', 'libxml');



// PHP Settings
	// $PRECHECK['PHP_SETTINGS'] = array('display_errors' => '1', 'safe_mode' => '0');



// Module specific checks

	$PRECHECK['WB_ADDONS'][ 'lib_setuphelper' ] = array( 'VERSION' => '1.04.000', 'OPERATOR' => '>=' );
	$PRECHECK['WB_ADDONS'][ 'lib_twig' ] = array( 'VERSION' => '1.24.0.0', 'OPERATOR' => '>=' );
	$PRECHECK['WB_ADDONS'][ 'lib_twig' ] = array( 'VERSION' => '1.20.0', 'OPERATOR' => '>=' );

// other specific checks
	// $status = file_exists(LEPTON_PATH . '/templates/blank/info.php');
	// $required = $TEXT['INSTALLED'];
	// $actual = ($status) ? $TEXT['INSTALLED'] : $TEXT['NOT_INSTALLED'];
	// $PRECHECK['CUSTOM_CHECKS'] = array('Template: blank' => array('REQUIRED' => $required, 'ACTUAL' => $actual, 'STATUS' => $status ) );



?>
