<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// load filemanager
	if ( count( get_included_files() ) < 2 ) die();

	global $lepton_filemanager;
	if ( is_object($lepton_filemanager) == FALSE ):
		require_once( '../../framework/class.lepton.filemanager.php' );
	endif;

/*
 * List of the files to register
 * ==============================
 *
 * Source: http://doc.lepton-cms.org/docu/english/home/addons/register-files.php
 *
 */

/* automatic registered files:
 * install.php
 * uninstall.php
 * upgrade.php
 * add.php
 * delete.php
 * modify.php
 * view.php
 */

// define the files to be registered
$files_to_register = array();
$files_to_register[] = '/modules/linker/README.de.php';
$files_to_register[] = '/modules/linker/README.en.php';
$files_to_register[] = '/modules/linker/_setup.php';
$files_to_register[] = '/modules/linker/ajax.add_link.php';
$files_to_register[] = '/modules/linker/ajax.autocomplete.php';
$files_to_register[] = '/modules/linker/ajax.confirm_link.php';
$files_to_register[] = '/modules/linker/ajax.delete_row.php';
$files_to_register[] = '/modules/linker/ajax.select_details.php';
$files_to_register[] = '/modules/linker/ajax.sort_rows.php';
$files_to_register[] = '/modules/linker/ajax.toggle_active.php';
$files_to_register[] = '/modules/linker/ajax.validate.php';
$files_to_register[] = '/modules/linker/css/backend.css';
$files_to_register[] = '/modules/linker/css/images/in_active_16.png';
$files_to_register[] = '/modules/linker/css/images/info_32.png';
$files_to_register[] = '/modules/linker/css/images/status_deleted_16.png';
$files_to_register[] = '/modules/linker/css/images/status_endvalid_16.png';
$files_to_register[] = '/modules/linker/css/images/status_ok_16.png';
$files_to_register[] = '/modules/linker/css/images/status_undefined_16.png';
$files_to_register[] = '/modules/linker/css/images/status_warning_16.png';
$files_to_register[] = '/modules/linker/css/images/toggle_active_0_16.png';
$files_to_register[] = '/modules/linker/css/images/toggle_active_1_16.png';
$files_to_register[] = '/modules/linker/css/images/visit_16.png';
$files_to_register[] = '/modules/linker/dialog.show_info.php';
$files_to_register[] = '/modules/linker/headers.inc.backend.php';
$files_to_register[] = '/modules/linker/headers.inc.php';
$files_to_register[] = '/modules/linker/headers.inc.tool.php';
$files_to_register[] = '/modules/linker/info.php';
$files_to_register[] = '/modules/linker/install_dependency.php';
$files_to_register[] = '/modules/linker/js/aCollapTable/LICENSE';
$files_to_register[] = '/modules/linker/js/aCollapTable/README.md';
$files_to_register[] = '/modules/linker/js/aCollapTable/bower.json';
$files_to_register[] = '/modules/linker/js/aCollapTable/jquery.aCollapTable.js';
$files_to_register[] = '/modules/linker/js/aCollapTable/jquery.aCollapTable.min.js';
$files_to_register[] = '/modules/linker/js/ajax.autocomplete.js';
$files_to_register[] = '/modules/linker/js/ajax.delete_row.js';
$files_to_register[] = '/modules/linker/js/ajax.select_details.js';
$files_to_register[] = '/modules/linker/js/ajax.sort_rows.js';
$files_to_register[] = '/modules/linker/js/ajax.toggle_active.js';
$files_to_register[] = '/modules/linker/js/dialog.js';
$files_to_register[] = '/modules/linker/js/textarea_autosize/autosize.js';
$files_to_register[] = '/modules/linker/js/textarea_autosize/autosize.min.js';
$files_to_register[] = '/modules/linker/js/textarea_autosize/read.me';
$files_to_register[] = '/modules/linker/js/textarea_autosize.js';
$files_to_register[] = '/modules/linker/js/tool.js';
$files_to_register[] = '/modules/linker/languages/DE.ajax.confirm_link.php';
$files_to_register[] = '/modules/linker/languages/DE.ajax.delete_row.php';
$files_to_register[] = '/modules/linker/languages/DE.ajax.select_details.php';
$files_to_register[] = '/modules/linker/languages/DE.ajax.sort_rows.php';
$files_to_register[] = '/modules/linker/languages/DE.ajax.toggle_active.php';
$files_to_register[] = '/modules/linker/languages/DE.ajax.validate.php';
$files_to_register[] = '/modules/linker/languages/DE.dialog.show_info.php';
$files_to_register[] = '/modules/linker/languages/DE.php';
$files_to_register[] = '/modules/linker/languages/DE.tool.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.confirm_link.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.delete_row.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.select_details.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.sort_rows.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.toggle_active.php';
$files_to_register[] = '/modules/linker/languages/EN.ajax.validate.php';
$files_to_register[] = '/modules/linker/languages/EN.dialog.show_info.php';
$files_to_register[] = '/modules/linker/languages/EN.php';
$files_to_register[] = '/modules/linker/languages/EN.tool.php';
$files_to_register[] = '/modules/linker/lib/functions/function.build_text_array.php';
$files_to_register[] = '/modules/linker/lib/functions/function.evaluate_status.php';
$files_to_register[] = '/modules/linker/lib/functions/function.execute_query.php';
$files_to_register[] = '/modules/linker/lib/functions/function.get_page_languages.php';
$files_to_register[] = '/modules/linker/lib/functions/function.init_link_type.php';
$files_to_register[] = '/modules/linker/lib/functions/function.input_filter.php';
$files_to_register[] = '/modules/linker/lib/functions/function.load_language.php';
$files_to_register[] = '/modules/linker/lib/functions/function.select_details.build_file_list.php';
$files_to_register[] = '/modules/linker/lib/functions/function.select_details.build_folder_tree.php';
$files_to_register[] = '/modules/linker/lib/functions/function.select_details.build_page_tree.php';
$files_to_register[] = '/modules/linker/lib/functions/function.select_details.build_section_list.php';
$files_to_register[] = '/modules/linker/lib/functions/function.transform_datetime_format.php';
$files_to_register[] = '/modules/linker/lib/lib.backend.config.php';
$files_to_register[] = '/modules/linker/lib/lib.backend.functions.php';
$files_to_register[] = '/modules/linker/lib/lib.config.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.add_link.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.autocomplete.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.confirm_link.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.delete_row.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.select_details.file_list.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.select_details.folder_tree.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.select_details.page_tree.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.select_details.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.select_details.section_list.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.sort_rows.php';
$files_to_register[] = '/modules/linker/lib/lib.data.ajax.toggle_active.php';
$files_to_register[] = '/modules/linker/lib/lib.data.dialog.show_info.php';
$files_to_register[] = '/modules/linker/lib/lib.data.tool.php';
$files_to_register[] = '/modules/linker/lib/lib.data.tool_links.php';
$files_to_register[] = '/modules/linker/lib/lib.tool_save_addgroup.php';
$files_to_register[] = '/modules/linker/lib/lib.tool_save_links.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.add_link.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.autocomplete.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.confirm_link.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.delete_row.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.sort_rows.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.toggle_active.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.ajax.validate.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.dialog.show_info.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.formvalues.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.tool.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.tool_addgroup.php';
$files_to_register[] = '/modules/linker/lib/lib.twig.tool_links.php';
$files_to_register[] = '/modules/linker/load_includes.php';
$files_to_register[] = '/modules/linker/precheck.php';
$files_to_register[] = '/modules/linker/register_initial.php';
$files_to_register[] = '/modules/linker/register_language.php';
$files_to_register[] = '/modules/linker/register_parser.php';
$files_to_register[] = '/modules/linker/templates/backend/ajax.add_link.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.confirm_link.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.delete_row.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.select_details.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.sort_rows.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.toggle_active.lte';
$files_to_register[] = '/modules/linker/templates/backend/ajax.validate.lte';
$files_to_register[] = '/modules/linker/templates/backend/dialog.show_info.lte';
$files_to_register[] = '/modules/linker/templates/backend/show.delete_row.lte';
$files_to_register[] = '/modules/linker/templates/backend/show.help.lte';
$files_to_register[] = '/modules/linker/templates/backend/show.toggle_active.lte';
$files_to_register[] = '/modules/linker/templates/backend/show_info.lte';
$files_to_register[] = '/modules/linker/templates/backend/tool.lte';
$files_to_register[] = '/modules/linker/templates/backend/tool_addgroup.lte';
$files_to_register[] = '/modules/linker/templates/backend/tool_links.lte';
$files_to_register[] = '/modules/linker/templates/backend/tool_links_detail.lte';
$files_to_register[] = '/modules/linker/tool.php';

// register the files
	$lepton_filemanager->register( $files_to_register );

?>
