<?php

/**  // € // to identify files as UTF8
 * managing links used in a site
 *
 * @module          linker
 * @author          Wolfgang Studer
 * @copyright       2017 Wolfgang Studer
 * @link            www.LEPTON-cms.org
 * @license         GNU General Public License
 * @license_terms   please see info.php of this module
 * @version         $Id: 1.08.000 | 2017-12-30
 * @lepador_link    http://www.lepton-cms.com/lepador/admintools/linker.php
 * @forum_link      http://forum.lepton-cms.org/viewtopic.php?f=66&t=3053
*/


// include class.secure.php to protect this file and the whole CMS!
	if ( defined('LEPTON_PATH') == TRUE ):
		include(LEPTON_PATH.'/framework/class.secure.php');
	else:
		$oneback = "../";
		$root = $oneback;
		$level = 1;
		while (( $level < 10 ) && ( file_exists( $root . '/framework/class.secure.php' ) == FALSE )):
			$root .= $oneback;
			$level += 1;
		endwhile;
	
		if ( file_exists($root.'/framework/class.secure.php') == TRUE ):
			include( $root . '/framework/class.secure.php' );
		else:
			trigger_error( sprintf("[ <b>%s</b> ] Can't include class.secure.php!", $_SERVER['SCRIPT_NAME']), E_USER_ERROR );
		endif;
	endif;
// end include class.secure.php


// define langauge array
	$linker_languages = array();
	if ( isset( $linker_modulePath ) == TRUE ):
		$linker_languages[] = array( 'language' => LANGUAGE
							, 'fallback' => 'EN'
							, 'path'     => $linker_modulePath . 'languages' . DIRECTORY_SEPARATOR
							);
	endif;
	if ( isset( $linker_templatePath ) == TRUE ):
		$linker_languages[] = array( 'language' => LANGUAGE
							, 'fallback' => 'EN'
							, 'path'     => $linker_templatePath . 'languages' . DIRECTORY_SEPARATOR
							);
	endif;


// load language files
	$function = $linker_modulePath
			. 'lib' . DIRECTORY_SEPARATOR . 'functions' . DIRECTORY_SEPARATOR
			. 'function.load_language.php';

	if ( is_file ( $function ) == TRUE ):
		include_once( $function );

		linker_load_language( $MOD_LINKER, $linker_languages, $linker_component, TRUE );
	endif;

?>
